# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/media/i2c/galaxycore,gc2145.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Galaxy Core 1/5'' UXGA CMOS Image Sensor

maintainers:
  - Alain Volmat <alain.volmat@foss.st.com>

description:
  The Galaxy Core GC2145 is a 2 Megapixel CMOS image sensor, for mobile
  phone camera applications and digital camera products. GC2145 incorporates a
  1616V x 1232H active pixel array, on-chip 10-bit ADC, and image signal
  processor allowing AE/AWB/interpolation/de-noise/color-conversion and
  gamma correction. Bayer RGB, RGB565 and YCbCr 4:2:2 can be provided by the
  sensor. It is programmable through an I2C interface. Image data is sent
  either through a parallel interface or through MIPI CSI-2.

allOf:
  - $ref: ../video-interface-devices.yaml#

properties:
  compatible:
    const: galaxycore,gc2145

  reg:
    const: 0x3c

  clocks:
    maxItems: 1

  powerdown-gpios:
    maxItems: 1

  reset-gpios:
    maxItems: 1

  iovdd-supply:
    description: Power Supply for I/O circuits (1.7 - 3V).

  avdd-supply:
    description: Power for analog circuit/sensor array (2.7 - 3V).

  dvdd-supply:
    description: Power for digital core (1.7 - 1.9V).

  orientation: true

  rotation: true

  port:
    $ref: /schemas/graph.yaml#/$defs/port-base

    properties:
      endpoint:
        $ref: /schemas/media/video-interfaces.yaml#
        unevaluatedProperties: false

        properties:
          link-frequencies: true

        required:
          - link-frequencies

    required:
      - endpoint

    additionalProperties: false

required:
  - compatible
  - reg
  - clocks
  - powerdown-gpios
  - reset-gpios
  - iovdd-supply
  - avdd-supply
  - dvdd-supply
  - port

additionalProperties: false

examples:
  - |
    #include <dt-bindings/gpio/gpio.h>

    i2c {
        #address-cells = <1>;
        #size-cells = <0>;

        camera@3c {
            compatible = "galaxycore,gc2145";
            reg = <0x3c>;
            clocks = <&clk_ext_camera>;
            iovdd-supply = <&scmi_v3v3_sw>;
            avdd-supply = <&scmi_v3v3_sw>;
            dvdd-supply = <&scmi_v3v3_sw>;
            powerdown-gpios = <&mcp23017 3 (GPIO_ACTIVE_LOW | GPIO_PUSH_PULL)>;
            reset-gpios = <&mcp23017 4 (GPIO_ACTIVE_LOW | GPIO_PUSH_PULL)>;

            port {
                endpoint {
                    remote-endpoint = <&mipid02_0>;
                    data-lanes = <1 2>;
                    link-frequencies = /bits/ 64 <120000000 192000000 240000000>;
                };
            };
        };
    };

...
